/*
 * Copyright (C) 2013-2014 Intel Corporation. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef YAMI_VERSION_H
#define YAMI_VERSION_H

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * YAMI_API_MAJOR_VERSION
 * The major version of yami api
 */
#define YAMI_API_MAJOR_VERSION    0

/**
 * YAMI_API_MINOR_VERSION
 * The minor version of yami api
 */
#define YAMI_API_MINOR_VERSION    7

/**
 * YAMI_API_MICRO_VERSION
 * The micro version of yami api
 */
#define YAMI_API_MICRO_VERSION    0

/**
 * YAMI_API_VERSION_STRING
 * The string version of yami api
 */
#define YAMI_API_VERSION_STRING    "0.7.0"


#define YAMI_API_VERSION_INT(major, minor, micro)    ((major << 24) | (minor << 16) | (micro << 8))

/**
 * YAMI_API_VERSION
 * The int version of yami api
 */
#define YAMI_API_VERSION    YAMI_API_VERSION_INT(YAMI_API_MAJOR_VERSION, YAMI_API_MINOR_VERSION, YAMI_API_MICRO_VERSION)

/**
 * YAMI_CHECK_API_VERSION
 * Result is 1 if YAMI_API_VERSION is greater than
 * YAMI_API_VERSION_INT(major, minor, micro)
 */
#define YAMI_CHECK_API_VERSION(major, minor, micro) (YAMI_API_VERSION >= YAMI_API_VERSION_INT(major, minor, micro))

/**
* yamiGetApiVersion
* return YAMI_API_VERSION;
*/
void yamiGetApiVersion(uint32_t *apiVersion);

#ifdef __cplusplus
};
#endif

#endif /* YAMI_VERSION_H */
